// 
// ALL RIGHTS RESERVED:
// ====================
// The contents of this file, and associated files in this directory, are 
// Copyright (C) Serial Port Tool(SPT) , all rights reserved, 2010.
// All software Source Code, Images, Database-Design and code, Graphics Design 
// and source files, and related content (collectively referred to as SOURCE) are 
// Copyright (C) SPT, 2009, All Rights Reserved.
// http://SerialPortTool.com
//
// Comm Operator is a Registered Trademark of SerialPortTool.com.

//About User Exe Sample
// This is sample exe can be called in AutoSend Rule. 

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CommOp.AutoSendPlugin
{
    //public enum EventType
    //{
    //    Start,      // start auto send
    //    Pause,      // pause auto send
    //    Resume,     // resume auto send
    //    DataReceived,   // on data received
    //    Loop            // loop,
    //}
    //public interface IAutoSendPlugin
    //{
    //    byte[] ProcessEvent(EventType eventType, byte[] data);
    //    bool IsSettingAvailable();      // if setting is available
    //    bool Setting(Form parent);     // call setting dialog
    //}


    /// <summary>
    /// EchoPlugin is a sample of implement IAutoSendPlugin.
    /// EchoPlugin will send the same data back
    /// </summary>
    public class EchoPlugin : IAutoSendPlugin 
    {
        /// <summary>
        /// Implement the interface of processEvent
        /// </summary>
        /// <param name="eventType">Event type</param>
        /// <param name="data">data for that event. Only ReceivedData event has data</param>
        /// <returns></returns>
        public byte[] ProcessEvent(EventType eventType, byte[] data)
        {
            byte[] returnData = null;
            if (eventType == EventType.DataReceived)
            {
                if(data != null)
                {
                    if (data.Length > 0)
                    {
                        returnData = new byte[data.Length];
                        Array.Copy(data, returnData, data.Length);
                        return returnData;
                    }
                }
            }
            return returnData;
        }

        /// <summary>
        /// Implement this interface if there is setting dialog needed for this
        /// for future usage
        /// </summary>
        /// <param name="parent"></param>
        /// <returns></returns>
        public bool Setting(Form parent)     // call setting dialog
        {
            return false;
        }

        /// <summary>
        /// method of if the setting dialog available, for future usage
        /// </summary>
        /// <returns></returns>
        public bool IsSettingAvailable()      // if setting is available
        {
            return false;
        }
        

    }
}
